﻿using System.Linq;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.EvolutionTracking;

namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
  public class SymbolicDataAnalysisExpressionBeforeCrossoverOperator : BeforeCrossoverOperator<ISymbolicExpressionTree> {
    public override IOperation Apply() {
      var result = base.Apply(); // the child will be added to the graph before the crossover
      var parents = ParentsParameter.ActualValue.ToList();
      var childVertex = GenealogyGraph[parents[0]].Last(); // use the parent since it is actually the child before crossover (and the ChildParameter doesn't have a value yet)
      //      var parentVertices = ExecutionContext.Scope.SubScopes.Select(s => CurrentGeneration[int.Parse(s.Name)]).ToList();

      // we add the breadth list of nodes of each parent as the data element of the arc from the parent to the child
      for (int i = 0; i < parents.Count; ++i) {
        var nodes = parents[i].IterateNodesPrefix().ToList();
        var arc = (IGenealogyGraphArc)childVertex.InArcs[i];
        arc.Data = nodes;
      }

      return result;
    }
  }
}
